import { ModalFormData as a } from '@minecraft/server-ui';
import { world as b, system as c } from '@minecraft/server';
import { isNumber as d, DEFAULT_MARGIN_LEFT as e, DEFAULT_MARGIN_TOP as f, DEFAULT_MARGIN_RIGHT as g, DEFAULT_MARGIN_BOTTOM as h, DEFAULT_TEXT_SIZE as i, DEFAULT_TEXT_TIMEOUT as j, DEFAULT_SHOW_IN_CHAT as k, DEFAULT_COLOR as l, DEFAULT_TEXT_COLOR as m } from "./VARIABLES";

function n(o) {
    let p = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(o);
    return p ? { x: parseInt(p[1], 16), y: parseInt(p[2], 16), z: parseInt(p[3], 16) } : null;
}

export function bubbleMenu(q) {
    const r = new a().title("Bubble Settings");
    let s = b.getDynamicProperty("bubble:marginLeft");
    let t = b.getDynamicProperty("bubble:marginTop");
    let u = b.getDynamicProperty("bubble:marginRight");
    let v = b.getDynamicProperty("bubble:marginBottom");
    let w = b.getDynamicProperty("bubble:textSize");
    let x = b.getDynamicProperty("bubble:timeout");
    let y = b.getDynamicProperty("bubble:showInChat");
    let z = b.getDynamicProperty("bubble:color");
    let A = b.getDynamicProperty("bubble:textColor");

    r["textField"]("Text size", "default", `${w}`);
    r["textField"]("Margin [left top right bottom]", "default", `${s} ${t} ${u} ${v}`);
    r["textField"]("Timeout (Seconds)", "default", `${x}`);
    r["textField"]("Bubble Color [r g b] or hex\nrgb ex. 255 255 255\nhex ex. #ffffff", "default", `${z.x} ${z.y} ${z.z}`);
    r["textField"]("Text Color", "default", `${A.x} ${A.y} ${A.z}`);
    r["toggle"]("Show in Chat", y);
    r["show"](q).then(B => {
        w = Number(B.formValues[0]) || i;
        let C = B.formValues[1].split(" ");
        s = Number(C[0]) || e;
        t = Number(C[1]) || f;
        u = Number(C[2]) || g;
        v = Number(C[3]) || h;
        x = Number(B.formValues[2]) || j;
        let D = B.formValues[3];
        if (D.startsWith("#")) {
            z = n(D);
            if (!z) z = l;
        } else {
            let E = D.split(" ");
            z.x = Math.floor(Math.max(Math.min(!d(E[0]) ? l.x : Number(E[0]), 255), 0));
            z.y = Math.floor(Math.max(Math.min(!d(E[1]) ? l.y : Number(E[1]), 255), 0));
            z.z = Math.floor(Math.max(Math.min(!d(E[2]) ? l.z : Number(E[2]), 255), 0));
        }
        let F = B.formValues[4];
        if (F.startsWith("#")) {
            A = n(F);
            if (!A) A = m;
        } else {
            let G = F.split(" ");
            A.x = Math.floor(Math.max(Math.min(!d(G[0]) ? m.x : Number(G[0]), 255), 0));
            A.y = Math.floor(Math.max(Math.min(!d(G[1]) ? m.y : Number(G[1]), 255), 0));
            A.z = Math.floor(Math.max(Math.min(!d(G[2]) ? m.z : Number(G[2]), 255), 0));
        }
        y = B.formValues[5];

        b.setDynamicProperty("bubble:textSize", w);
        b.setDynamicProperty("bubble:marginLeft", s);
        b.setDynamicProperty("bubble:marginTop", t);
        b.setDynamicProperty("bubble:marginRight", u);
        b.setDynamicProperty("bubble:marginBottom", v);
        b.setDynamicProperty("bubble:timeout", x);
        b.setDynamicProperty("bubble:showInChat", y);
        b.setDynamicProperty("bubble:color", z);
        b.setDynamicProperty("bubble:textColor", A);
        b.getPlayers().some(H => H.onScreenDisplay.setActionBar("Bubble was updated"));
    }).catch(I => { console.warn(I); });
}

export default { bubbleMenu };
